import json
from datetime import datetime
from pathlib import Path
from typing import Any

from .blueprint import bp


@bp.get("/version")
def get_version() -> dict[str, Any]:
    portal_version_path = Path("./PORTAL_VERSION")
    if portal_version_path.is_file():
        with open("PORTAL_VERSION") as f:
            version_info = json.load(f)
    else:
        version_info = {"datetime": datetime.now().isoformat()}

    return {
        "authors": [
            {
                "name": "Jakob Moser",
                "email": "moser@cl.uni-heidelberg.de",
                "role": "Maintainer",
            },
        ],
        "commit": version_info.get("commit"),
        "datetime": version_info["datetime"],
        "isDevelop": version_info.get("commit") is None,
    }
